searchNodes=[{"ref":"Mix.Tasks.Compile.PhoenixSwagger.html","title":"Mix.Tasks.Compile.PhoenixSwagger","type":"task","doc":"See documentation for Mix.Tasks.Phx.Swagger.Generate"},{"ref":"Mix.Tasks.Compile.PhoenixSwagger.html#filter_errors/1","title":"Mix.Tasks.Compile.PhoenixSwagger.filter_errors/1","type":"function","doc":""},{"ref":"Mix.Tasks.Compile.PhoenixSwagger.html#run/1","title":"Mix.Tasks.Compile.PhoenixSwagger.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"Mix.Tasks.Phx.Swagger.Generate.html","title":"Mix.Tasks.Phx.Swagger.Generate","type":"task","doc":"Generates swagger.json file based on phoenix router and controllers. Usage: mix phx.swagger.generate Swagger file configuration must be defined in the project config, eg: config :your_app, :phoenix_swagger, swagger_files: %{ &quot;priv/static/swagger.json&quot; =&gt; [router: YourAppWeb.Router, endpoint: YourAppWeb.Endpoint] # ... additional swagger files can be added here }"},{"ref":"Mix.Tasks.Phx.Swagger.Generate.html#default_swagger_info/0","title":"Mix.Tasks.Phx.Swagger.Generate.default_swagger_info/0","type":"function","doc":""},{"ref":"Mix.Tasks.Phx.Swagger.Generate.html#run/1","title":"Mix.Tasks.Phx.Swagger.Generate.run/1","type":"function","doc":"A task needs to implement run which receives a list of command line args. Callback implementation for Mix.Task.run/1."},{"ref":"PhoenixSwagger.html","title":"PhoenixSwagger","type":"module","doc":"The PhoenixSwagger module provides macros for defining swagger operations and schemas. Example: use PhoenixSwagger swagger_path :create do post &quot;/api/v1/{team}/users&quot; summary &quot;Create a new user&quot; consumes &quot;application/json&quot; produces &quot;application/json&quot; parameters do user :body, Schema.ref(:User), &quot;user attributes&quot; team :path, :string, &quot;Users team ID&quot; end response 200, &quot;OK&quot;, Schema.ref(:User) end def swagger_definitions do %{ User: swagger_schema do title &quot;User&quot; description &quot;A user of the application&quot; properties do name :string, &quot;Users name&quot;, required: true id :string, &quot;Unique identifier&quot;, required: true address :string, &quot;Home adress&quot; end end } end"},{"ref":"PhoenixSwagger.html#json_library/0","title":"PhoenixSwagger.json_library/0","type":"function","doc":"Use JSON library from phoenix configuration"},{"ref":"PhoenixSwagger.html#start/2","title":"PhoenixSwagger.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"PhoenixSwagger.html#swagger_path/2","title":"PhoenixSwagger.swagger_path/2","type":"macro","doc":"Swagger operations (aka &quot;paths&quot;) are defined inside a swagger_path block. Within the do-end block, the DSL provided by the PhoenixSwagger.Path module can be used. The DSL is any chain of functions with first argument being a PhoenixSwagger.Path.PathObject struct. The verb and path can be set explicitly using the get, put, post, patch, delete functions, or inferred from the phoenix router automatically. Swagger tags will default to match the module name with trailing Controller removed. Eg operations defined in module MyApp.UserController will have tags: [&quot;User&quot;]. Swagger operationId will default to the fully qualified action function name. Eg index action in MyApp.UserController will have operationId: &quot;MyApp.UserController.index&quot;. Example defmodule ExampleController do use ExampleApp.Web, :controller use PhoenixSwagger swagger_path :index do get &quot;/users&quot; summary &quot;Get users&quot; description &quot;Get users, filtering by account ID&quot; parameter :query, :id, :integer, &quot;account id&quot;, required: true response 200, &quot;Description&quot;, :Users tag &quot;users&quot; end def index(conn, _params) do posts = Repo.all(Post) render(conn, &quot;index.json&quot;, posts: posts) end end"},{"ref":"PhoenixSwagger.html#swagger_schema/1","title":"PhoenixSwagger.swagger_schema/1","type":"macro","doc":"Builds a swagger schema map using a DSL from the functions defined in PhoenixSwagger.Schema. Example iex&gt; use PhoenixSwagger ...&gt; swagger_schema do ...&gt; title &quot;Pet&quot; ...&gt; description &quot;A pet in the pet store&quot; ...&gt; properties do ...&gt; id :integer, &quot;Unique identifier&quot;, required: true, format: :int64 ...&gt; name :string, &quot;Pets name&quot;, required: true ...&gt; tags array(:string), &quot;Tag categories for this pet&quot; ...&gt; end ...&gt; additional_properties false ...&gt; end %{ &quot;title&quot; =&gt; &quot;Pet&quot;, &quot;type&quot; =&gt; &quot;object&quot;, &quot;description&quot; =&gt; &quot;A pet in the pet store&quot;, &quot;properties&quot; =&gt; %{ &quot;id&quot; =&gt; %{ &quot;description&quot; =&gt; &quot;Unique identifier&quot;, &quot;format&quot; =&gt; &quot;int64&quot;, &quot;type&quot; =&gt; &quot;integer&quot; }, &quot;name&quot; =&gt; %{ &quot;description&quot; =&gt; &quot;Pets name&quot;, &quot;type&quot; =&gt; &quot;string&quot; }, &quot;tags&quot; =&gt; %{ &quot;description&quot; =&gt; &quot;Tag categories for this pet&quot;, &quot;items&quot; =&gt; %{ &quot;type&quot; =&gt; &quot;string&quot; }, &quot;type&quot; =&gt; &quot;array&quot; } }, &quot;required&quot; =&gt; [&quot;name&quot;, &quot;id&quot;], &quot;additionalProperties&quot; =&gt; false } iex&gt; use PhoenixSwagger ...&gt; swagger_schema do ...&gt; title &quot;Phone&quot; ...&gt; description &quot;An 8 digit phone number with optional 2 digit area code&quot; ...&gt; type :string ...&gt; max_length 11 ...&gt; pattern ~S&quot;^(([0-9]{2}))?[0-9]{4}-[0-9]{4}$&quot; ...&gt; end %{ &quot;description&quot; =&gt; &quot;An 8 digit phone number with optional 2 digit area code&quot;, &quot;maxLength&quot; =&gt; 11, &quot;pattern&quot; =&gt; &quot;^(\\([0-9]{2}\\))?[0-9]{4}-[0-9]{4}$&quot;, &quot;title&quot; =&gt; &quot;Phone&quot;, &quot;type&quot; =&gt; &quot;string&quot; }"},{"ref":"PhoenixSwagger.ConnValidator.html","title":"PhoenixSwagger.ConnValidator","type":"module","doc":""},{"ref":"PhoenixSwagger.ConnValidator.html#validate/1","title":"PhoenixSwagger.ConnValidator.validate/1","type":"function","doc":"Validate a request. Feel free to use it in your own Plugs. Returns: {:ok, conn} on success {:error, :no_matching_path} if the request path could not be mapped to a schema {:error, message, path} if the request was mapped but failed validation {:error, [{message, path}], path} if more than one validation error has been detected"},{"ref":"PhoenixSwagger.JsonApi.html","title":"PhoenixSwagger.JsonApi","type":"module","doc":"This module defines a DSL for defining swagger definitions in a JSON-API conformant format. Examples use PhoenixSwagger def swagger_definitions do %{ UserResource: JsonApi.resource do description &quot;A user that may have one or more supporter pages.&quot; attributes do phone :string, &quot;Users phone number&quot; full_name :string, &quot;Full name&quot; user_updated_at :string, &quot;Last update timestamp UTC&quot;, format: &quot;ISO-8601&quot; user_created_at :string, &quot;First created timestamp UTC&quot; email :string, &quot;Email&quot;, required: true birthday :string, &quot;Birthday in YYYY-MM-DD format&quot; address Schema.ref(:Address), &quot;Users address&quot; end link :self, &quot;The link to this user resource&quot; relationship :posts end, Users: JsonApi.page(:UserResource), User: JsonApi.single(:UserResource) } end swagger_path :index do get &quot;/api/v1/users&quot; paging size: &quot;page[size]&quot;, number: &quot;page[number]&quot; response 200, &quot;OK&quot;, Schema.ref(:Users) end"},{"ref":"PhoenixSwagger.JsonApi.html#attribute/5","title":"PhoenixSwagger.JsonApi.attribute/5","type":"function","doc":"Defines an attribute in a JSON-API schema. Name, type and description are accepted as positional arguments, but any other schema properties can be set through the trailing keyword arguments list. As a convenience, required: true can be passed in the keyword args, causing the name of this attribute to be added to the &quot;required&quot; list of the attributes schema."},{"ref":"PhoenixSwagger.JsonApi.html#attributes/2","title":"PhoenixSwagger.JsonApi.attributes/2","type":"macro","doc":"Defines a block of attributes for a JSON-API resource. Within this block, each function call will be translated into a call to the PhoenixSwagger.JsonApi.attribute function. Example description(&quot;A User&quot;) attributes do name :string, &quot;Full name of the user&quot;, required: true dateOfBirth :string, &quot;Date of Birth&quot;, format: &quot;ISO-8601&quot;, required: false end translates to: description(&quot;A User&quot;) |&gt; attribute(:name, :string, &quot;Full name of the user&quot;, required: true) |&gt; attribute(:dateOfBirth, :string, &quot;Date of Birth&quot;, format: &quot;ISO-8601&quot;, required: false)"},{"ref":"PhoenixSwagger.JsonApi.html#link/3","title":"PhoenixSwagger.JsonApi.link/3","type":"function","doc":"Defines a link with name and description"},{"ref":"PhoenixSwagger.JsonApi.html#page/1","title":"PhoenixSwagger.JsonApi.page/1","type":"function","doc":"Defines a schema for a top level json-api document with an array of resources as primary data. The given resource should be the name of a JSON-API resource defined with the resource/1 macro"},{"ref":"PhoenixSwagger.JsonApi.html#relationship/3","title":"PhoenixSwagger.JsonApi.relationship/3","type":"function","doc":"Defines a relationship Optionally can pass type: :has_many or type: :has_one to determine whether to structure the relationship as an object or array. Defaults to :has_one"},{"ref":"PhoenixSwagger.JsonApi.html#resource/1","title":"PhoenixSwagger.JsonApi.resource/1","type":"macro","doc":"Defines a schema for a JSON-API resource, without the enclosing top-level document."},{"ref":"PhoenixSwagger.JsonApi.html#single/1","title":"PhoenixSwagger.JsonApi.single/1","type":"function","doc":"Defines a schema for a top level json-api document with a single primary data resource. The given resource should be the name of a JSON-API resource defined with the resource/1 macro"},{"ref":"PhoenixSwagger.Path.html","title":"PhoenixSwagger.Path","type":"module","doc":"Defines the swagger path DSL for specifying Controller actions. This module should not be imported directly, it will be automatically imported in the scope of a swagger_path macro body. Examples use PhoenixSwagger swagger_path :index do get &quot;/users&quot; produces &quot;application/json&quot; paging parameter :id, :query, :integer, &quot;user id&quot;, required: true tag &quot;Users&quot; response 200 &quot;User resource&quot; :User response 404 &quot;User not found&quot; end"},{"ref":"PhoenixSwagger.Path.html#consumes/2","title":"PhoenixSwagger.Path.consumes/2","type":"function","doc":"Adds a mime-type to the consumes list of the operation of a swagger %PathObject{}"},{"ref":"PhoenixSwagger.Path.html#delete/2","title":"PhoenixSwagger.Path.delete/2","type":"function","doc":"Initializes a PathObject with verb &quot;delete&quot; and given path"},{"ref":"PhoenixSwagger.Path.html#deprecated/2","title":"PhoenixSwagger.Path.deprecated/2","type":"function","doc":"Adds the deprecation section to the operation of a swagger %PathObject{}"},{"ref":"PhoenixSwagger.Path.html#description/2","title":"PhoenixSwagger.Path.description/2","type":"function","doc":"Adds the description section to the operation of a swagger %PathObject{}"},{"ref":"PhoenixSwagger.Path.html#expand_response_example/2","title":"PhoenixSwagger.Path.expand_response_example/2","type":"function","doc":""},{"ref":"PhoenixSwagger.Path.html#get/2","title":"PhoenixSwagger.Path.get/2","type":"function","doc":"Initializes a PathObject with verb &quot;get&quot; and given path"},{"ref":"PhoenixSwagger.Path.html#head/2","title":"PhoenixSwagger.Path.head/2","type":"function","doc":"Initializes a PathObject with verb &quot;head&quot; and given path"},{"ref":"PhoenixSwagger.Path.html#nest/1","title":"PhoenixSwagger.Path.nest/1","type":"function","doc":"Converts the %PathObject{} struct into the nested JSON form expected by swagger"},{"ref":"PhoenixSwagger.Path.html#operation_id/2","title":"PhoenixSwagger.Path.operation_id/2","type":"function","doc":"Adds the operationId section to the operation of a swagger %PathObject{}"},{"ref":"PhoenixSwagger.Path.html#options/2","title":"PhoenixSwagger.Path.options/2","type":"function","doc":"Initializes a PathObject with verb &quot;options&quot; and given path"},{"ref":"PhoenixSwagger.Path.html#paging/2","title":"PhoenixSwagger.Path.paging/2","type":"function","doc":"Adds page size, number and offset parameters to the operation of a swagger %PathObject{} The names default to &quot;page_size&quot; and &quot;page&quot; for ease of use with scriviner_ecto, but can be overridden. Examples get &quot;/api/pets/&quot; paging response 200, &quot;OK&quot; get &quot;/api/pets/dogs&quot; paging size: &quot;page_size&quot;, number: &quot;count&quot; response 200, &quot;OK&quot; get &quot;/api/pets/cats&quot; paging size: &quot;limit&quot;, offset: &quot;offset&quot; response 200, &quot;OK&quot;"},{"ref":"PhoenixSwagger.Path.html#parameter/6","title":"PhoenixSwagger.Path.parameter/6","type":"function","doc":"Adds a parameter to the operation of a swagger %PathObject{}"},{"ref":"PhoenixSwagger.Path.html#parameters/2","title":"PhoenixSwagger.Path.parameters/2","type":"macro","doc":"Defines multiple parameters for an operation with a custom DSL syntax Example swagger_path :create do post &quot;/api/v1/{team}/users&quot; summary &quot;Create a new user&quot; parameters do user :body, Schema.ref(:User), &quot;user attributes&quot; team :path, :string, &quot;Users team ID&quot; end response 200, &quot;OK&quot;, :User end"},{"ref":"PhoenixSwagger.Path.html#patch/2","title":"PhoenixSwagger.Path.patch/2","type":"function","doc":"Initializes a PathObject with verb &quot;patch&quot; and given path"},{"ref":"PhoenixSwagger.Path.html#post/2","title":"PhoenixSwagger.Path.post/2","type":"function","doc":"Initializes a PathObject with verb &quot;post&quot; and given path"},{"ref":"PhoenixSwagger.Path.html#produces/2","title":"PhoenixSwagger.Path.produces/2","type":"function","doc":"Adds a mime-type to the produces list of the operation of a swagger %PathObject{}"},{"ref":"PhoenixSwagger.Path.html#put/2","title":"PhoenixSwagger.Path.put/2","type":"function","doc":"Initializes a PathObject with verb &quot;put&quot; and given path"},{"ref":"PhoenixSwagger.Path.html#response/3","title":"PhoenixSwagger.Path.response/3","type":"function","doc":"Adds a response to the operation of a swagger %PathObject{}, without a schema"},{"ref":"PhoenixSwagger.Path.html#response/5","title":"PhoenixSwagger.Path.response/5","type":"function","doc":"Adds a response to the operation of a swagger %PathObject{}, with a schema Optional keyword args can be provided for headers and examples If the mime-type is known from the produces list, then a single can be given as a shorthand. Example get &quot;/users/{id}&quot; produces &quot;application/json&quot; parameter :id, :path, :integer, &quot;user id&quot;, required: true response 200, &quot;Success&quot;, :User, examples: %{&quot;application/json&quot;: %{id: 1, name: &quot;Joe&quot;}} get &quot;/users/{id}&quot; produces &quot;application/json&quot; parameter :id, :path, :integer, &quot;user id&quot;, required: true response 200, &quot;Success&quot;, :User, example: %{id: 1, name: &quot;Joe&quot;}"},{"ref":"PhoenixSwagger.Path.html#security/2","title":"PhoenixSwagger.Path.security/2","type":"function","doc":"Adds the security section to the operation of a swagger %PathObject{}"},{"ref":"PhoenixSwagger.Path.html#summary/2","title":"PhoenixSwagger.Path.summary/2","type":"function","doc":"Adds the summary section to the operation of a swagger %PathObject{}"},{"ref":"PhoenixSwagger.Path.html#tag/2","title":"PhoenixSwagger.Path.tag/2","type":"function","doc":"Adds a tag to the operation of a swagger %PathObject{}"},{"ref":"PhoenixSwagger.Path.OperationObject.html","title":"PhoenixSwagger.Path.OperationObject","type":"module","doc":"A swagger operation object ties together parameters, responses, etc. See http://swagger.io/specification/#operationObject"},{"ref":"PhoenixSwagger.Path.Parameter.html","title":"PhoenixSwagger.Path.Parameter","type":"module","doc":"A swagger parameter definition, similar to a Schema, but swagger defines parameter name (and some other options) to be part of the parameter object itself. See http://swagger.io/specification/#parameterObject"},{"ref":"PhoenixSwagger.Path.PathObject.html","title":"PhoenixSwagger.Path.PathObject","type":"module","doc":"The DSL builds paths out of individual operations, so this is a flattened version of a swagger Path. The nest function will convert this to a nested map before final conversion to a JSON map. See http://swagger.io/specification/#pathsObject"},{"ref":"PhoenixSwagger.Path.ResponseObject.html","title":"PhoenixSwagger.Path.ResponseObject","type":"module","doc":"A swagger response definition. The response status (200, 404, etc.) is the key in the containing map. See http://swagger.io/specification/#responseObject"},{"ref":"PhoenixSwagger.Plug.SwaggerUI.html","title":"PhoenixSwagger.Plug.SwaggerUI","type":"module","doc":"Swagger UI in a plug Usage: Generate a swagger file and place it in your applications priv/static dir: mix phoenix.swagger.generate priv/static/myapp.json Add a swagger scope to your router, and forward all requests to SwaggerUI scope &quot;myapp/api/swagger&quot; do forward &quot;/&quot;, PhoenixSwagger.Plug.SwaggerUI, otp_app: :myapp, swagger_file: &quot;myapp.json&quot; end Run the server with mix phoenix.server and browse to localhost:8080/myapp/api/swagger/, swagger-ui should be shown with your swagger spec loaded."},{"ref":"PhoenixSwagger.Plug.SwaggerUI.html#call/2","title":"PhoenixSwagger.Plug.SwaggerUI.call/2","type":"function","doc":"Plug.call callback"},{"ref":"PhoenixSwagger.Plug.SwaggerUI.html#init/1","title":"PhoenixSwagger.Plug.SwaggerUI.init/1","type":"function","doc":"Plug.init callback Options: otp_app (required) The name of the app has is hosting the swagger file swagger_file (required) The name of the file, eg &quot;swagger.json&quot;"},{"ref":"PhoenixSwagger.Plug.Validate.html","title":"PhoenixSwagger.Plug.Validate","type":"module","doc":"A plug to automatically validate all requests in a given scope. Please make sure to: load Swagger specs at appliction start with PhoenixSwagger.Validator.parse_swagger_schema/1 set conn.private.phoenix_swagger.valid to true to skip validation"},{"ref":"PhoenixSwagger.Plug.Validate.html#call/2","title":"PhoenixSwagger.Plug.Validate.call/2","type":"function","doc":""},{"ref":"PhoenixSwagger.Plug.Validate.html#init/1","title":"PhoenixSwagger.Plug.Validate.init/1","type":"function","doc":"Plug.init callback Options: :validation_failed_status the response status to set when parameter validation fails, defaults to 400."},{"ref":"PhoenixSwagger.Schema.html","title":"PhoenixSwagger.Schema","type":"module","doc":"Struct and helpers for swagger schema. Fields should reflect the swagger SchemaObject specification http://swagger.io/specification/#schemaObject"},{"ref":"PhoenixSwagger.Schema.html#additional_properties/2","title":"PhoenixSwagger.Schema.additional_properties/2","type":"function","doc":"Boolean indicating that additional properties are allowed, or a schema to be used for validating any additional properties not listed in properties. Default behaviour is to allow additional properties. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :object} ...&gt; |&gt; Schema.property(:name, :string, &quot;Full name&quot;, maxLength: 255) ...&gt; |&gt; Schema.additional_properties(false) %PhoenixSwagger.Schema{ type: :object, properties: %{ name: %PhoenixSwagger.Schema{ type: :string, description: &quot;Full name&quot;, maxLength: 255 } }, additionalProperties: false } iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :object} ...&gt; |&gt; Schema.property(:name, :string, &quot;Full name&quot;, maxLength: 255) ...&gt; |&gt; Schema.additional_properties(%Schema{type: :number}) %PhoenixSwagger.Schema{ type: :object, properties: %{ name: %PhoenixSwagger.Schema{ type: :string, description: &quot;Full name&quot;, maxLength: 255 } }, additionalProperties: %PhoenixSwagger.Schema{ type: :number } }"},{"ref":"PhoenixSwagger.Schema.html#all_of/2","title":"PhoenixSwagger.Schema.all_of/2","type":"function","doc":"Used to combine multiple schemas, requiring a value to conform to all schemas. Can be used in conjunction with discriminator to define polymorphic inheritance relationships. See http://swagger.io/specification/#composition-and-inheritance--polymorphism--83 Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{} ...&gt; |&gt; Schema.all_of([Schema.ref(&quot;#definitions/Contact&quot;), Schema.ref(&quot;#definitions/CreditHistory&quot;)]) %PhoenixSwagger.Schema{ allOf: [ %PhoenixSwagger.Schema{&#39;$ref&#39;: &quot;#definitions/Contact&quot;}, %PhoenixSwagger.Schema{&#39;$ref&#39;: &quot;#definitions/CreditHistory&quot;}, ] }"},{"ref":"PhoenixSwagger.Schema.html#array/1","title":"PhoenixSwagger.Schema.array/1","type":"function","doc":"Construct an array schema, where the array items schema is a ref to the given name. Example iex&gt; PhoenixSwagger.Schema.array(:User) %PhoenixSwagger.Schema{ items: %PhoenixSwagger.Schema{&quot;$ref&quot;: &quot;#/definitions/User&quot;}, type: :array } iex&gt; PhoenixSwagger.Schema.array(:string) %PhoenixSwagger.Schema{ items: %PhoenixSwagger.Schema{type: :string}, type: :array }"},{"ref":"PhoenixSwagger.Schema.html#default/2","title":"PhoenixSwagger.Schema.default/2","type":"function","doc":"Sets the default value for the schema. The value provided should validate against the schema sucessfully. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :string, format: :datetime} ...&gt; |&gt; Schema.default(&quot;2017-01-01T00:00:00Z&quot;) %PhoenixSwagger.Schema{ type: :string, format: :datetime, default: &quot;2017-01-01T00:00:00Z&quot; }"},{"ref":"PhoenixSwagger.Schema.html#description/2","title":"PhoenixSwagger.Schema.description/2","type":"function","doc":"Sets the description for the schema. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{} |&gt; Schema.description(&quot;A user&quot;) %PhoenixSwagger.Schema{description: &quot;A user&quot;}"},{"ref":"PhoenixSwagger.Schema.html#discriminator/2","title":"PhoenixSwagger.Schema.discriminator/2","type":"function","doc":"Specifies the name of a property that identifies the polymorphic schema for a JSON object. The value of this property should be the name of this schema, or another schema that inherits from this schema using all_of. See http://swagger.io/specification/#composition-and-inheritance--polymorphism--83 ## Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{} ...&gt; |&gt; Schema.type(:object) ...&gt; |&gt; Schema.title(&quot;Pet&quot;) ...&gt; |&gt; Schema.property(:pet_type, :string, &quot;polymorphic pet schema type&quot;, example: &quot;Dog&quot;) ...&gt; |&gt; Schema.discriminator(:pet_type) %Schema{ type: :object, title: &quot;Pet&quot;, properties: %{ pet_type: %Schema{ type: :string, description: &quot;polymorphic pet schema type&quot;, example: &quot;Dog&quot; } }, discriminator: :pet_type, required: [:pet_type] }"},{"ref":"PhoenixSwagger.Schema.html#enum/2","title":"PhoenixSwagger.Schema.enum/2","type":"function","doc":"Restricts the schema to a fixed set of values. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :string} ...&gt; |&gt; Schema.enum([&quot;red&quot;, &quot;yellow&quot;, &quot;green&quot;]) %PhoenixSwagger.Schema{type: :string, enum: [&quot;red&quot;, &quot;yellow&quot;, &quot;green&quot;]}"},{"ref":"PhoenixSwagger.Schema.html#example/2","title":"PhoenixSwagger.Schema.example/2","type":"function","doc":"Adds an example of the schema. ## Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :object, properties: %{phone_number: %Schema{type: :string}}} ...&gt; |&gt; Schema.example(%{phone_number: &quot;555-123-456&quot;}) %PhoenixSwagger.Schema{ type: :object, properties: %{ phone_number: %PhoenixSwagger.Schema{ type: :string } }, example: %{phone_number: &quot;555-123-456&quot;} }"},{"ref":"PhoenixSwagger.Schema.html#exclusive_maximum/2","title":"PhoenixSwagger.Schema.exclusive_maximum/2","type":"function","doc":"Boolean indicating that value for maximum is excluded from the valid range. When true: x &lt; maximum, when false: x &lt;= maximum Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :number} ...&gt; |&gt; Schema.maximum(128) ...&gt; |&gt; Schema.exclusive_maximum(true) %PhoenixSwagger.Schema{ type: :number, maximum: 128, exclusiveMaximum: true }"},{"ref":"PhoenixSwagger.Schema.html#exclusive_minimum/2","title":"PhoenixSwagger.Schema.exclusive_minimum/2","type":"function","doc":"Boolean indicating that value for minimum is excluded from the valid range. When true: x &gt; minimum, when false: x =&gt; minimum Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :number} ...&gt; |&gt; Schema.minimum(16) ...&gt; |&gt; Schema.exclusive_minimum(true) %PhoenixSwagger.Schema{ type: :number, minimum: 16, exclusiveMinimum: true }"},{"ref":"PhoenixSwagger.Schema.html#format/2","title":"PhoenixSwagger.Schema.format/2","type":"function","doc":"Sets the format of a Schema with type: :string Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :string} |&gt; Schema.format(:datetime) %PhoenixSwagger.Schema{type: :string, format: :datetime}"},{"ref":"PhoenixSwagger.Schema.html#items/2","title":"PhoenixSwagger.Schema.items/2","type":"function","doc":"Sets the schema/s for the items of an array. Use a single schema for arrays when each item should have the same schema. Use a list of schemas when the array represents a tuple, each element will be validated against the corresponding schema in the items list. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :array} ...&gt; |&gt; Schema.items(%Schema{type: :string}) %PhoenixSwagger.Schema{type: :array, items: %PhoenixSwagger.Schema{type: :string}} iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :array} ...&gt; |&gt; Schema.items([%Schema{type: :string}, %Schema{type: :number}]) %PhoenixSwagger.Schema{ type: :array, items: [%PhoenixSwagger.Schema{type: :string}, %PhoenixSwagger.Schema{type: :number}] }"},{"ref":"PhoenixSwagger.Schema.html#max_items/2","title":"PhoenixSwagger.Schema.max_items/2","type":"function","doc":"Restricts the maximimum number of items in an array schema. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :array} ...&gt; |&gt; Schema.max_items(25) %PhoenixSwagger.Schema{type: :array, maxItems: 25}"},{"ref":"PhoenixSwagger.Schema.html#max_length/2","title":"PhoenixSwagger.Schema.max_length/2","type":"function","doc":"Constrains the maximum length of a string to the given value. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :string} ...&gt; |&gt; Schema.max_length(255) %PhoenixSwagger.Schema{type: :string, maxLength: 255}"},{"ref":"PhoenixSwagger.Schema.html#max_properties/2","title":"PhoenixSwagger.Schema.max_properties/2","type":"function","doc":"Limits the maximum number of properties an object schema may contain. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :object} ...&gt; |&gt; Schema.max_properties(10) %PhoenixSwagger.Schema{type: :object, maxProperties: 10}"},{"ref":"PhoenixSwagger.Schema.html#maximum/2","title":"PhoenixSwagger.Schema.maximum/2","type":"function","doc":"Specifies a maximum numeric value for :integer or :number types. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :integer} ...&gt; |&gt; Schema.maximum(100) %PhoenixSwagger.Schema{type: :integer, maximum: 100}"},{"ref":"PhoenixSwagger.Schema.html#min_items/2","title":"PhoenixSwagger.Schema.min_items/2","type":"function","doc":"Restricts the minimum number of items in an array schema. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :array} ...&gt; |&gt; Schema.min_items(1) %PhoenixSwagger.Schema{type: :array, minItems: 1}"},{"ref":"PhoenixSwagger.Schema.html#min_length/2","title":"PhoenixSwagger.Schema.min_length/2","type":"function","doc":"Constrains the minimum length of a string to the given value. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :string} ...&gt; |&gt; Schema.min_length(32) %PhoenixSwagger.Schema{type: :string, minLength: 32}"},{"ref":"PhoenixSwagger.Schema.html#min_properties/2","title":"PhoenixSwagger.Schema.min_properties/2","type":"function","doc":"Limits the minimum number of properties an object schema may contain. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :object} ...&gt; |&gt; Schema.min_properties(1) %PhoenixSwagger.Schema{type: :object, minProperties: 1}"},{"ref":"PhoenixSwagger.Schema.html#minimum/2","title":"PhoenixSwagger.Schema.minimum/2","type":"function","doc":"Specifies a minimum numeric value for :integer or :number types. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :integer} ...&gt; |&gt; Schema.minimum(10) %PhoenixSwagger.Schema{type: :integer, minimum: 10}"},{"ref":"PhoenixSwagger.Schema.html#multiple_of/2","title":"PhoenixSwagger.Schema.multiple_of/2","type":"function","doc":"Limits a values of numeric type (:integer or :number) to multiples of the given amount. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :number} ...&gt; |&gt; Schema.multiple_of(7) %PhoenixSwagger.Schema{type: :number, multipleOf: 7}"},{"ref":"PhoenixSwagger.Schema.html#new/1","title":"PhoenixSwagger.Schema.new/1","type":"macro","doc":"Construct a new %Schema{} struct using the schema DSL. This macro is similar to PhoenixSwagger.swagger_schema, except that it produces a Schema struct instead of a plain map with string keys. Example iex&gt; require PhoenixSwagger.Schema, as: Schema ...&gt; Schema.new do ...&gt; type :object ...&gt; properties do ...&gt; name :string, &quot;user name&quot;, required: true ...&gt; date_of_birth :string, &quot;date of birth&quot;, format: :datetime ...&gt; end ...&gt; end %Schema{ type: :object, properties: %{ name: %Schema { type: :string, description: &quot;user name&quot; }, date_of_birth: %Schema { type: :string, format: :datetime, description: &quot;date of birth&quot; } }, required: [:name] }"},{"ref":"PhoenixSwagger.Schema.html#nullable/2","title":"PhoenixSwagger.Schema.nullable/2","type":"function","doc":"Sets the x-nullable vendor extension property for the schema. ## Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :string} |&gt; Schema.nullable(true) %Schema{ type: :string, &#39;x-nullable&#39;: true }"},{"ref":"PhoenixSwagger.Schema.html#pattern/2","title":"PhoenixSwagger.Schema.pattern/2","type":"function","doc":"Restricts a string schema to match a regular expression, given as a string. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :string} ...&gt; |&gt; Schema.pattern(~S&quot;^(([0-9]{2}))?[0-9]{4}-[0-9]{4}$&quot;) %PhoenixSwagger.Schema{type: :string, pattern: ~S&quot;^(([0-9]{2}))?[0-9]{4}-[0-9]{4}$&quot;}"},{"ref":"PhoenixSwagger.Schema.html#properties/2","title":"PhoenixSwagger.Schema.properties/2","type":"macro","doc":"Defines multiple properties for a schema with a custom DSL syntax Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :object} ...&gt; |&gt; Schema.properties do ...&gt; name :string, &quot;Full Name&quot;, required: true ...&gt; dateOfBirth :string, &quot;Date of birth&quot;, format: :datetime ...&gt; end %PhoenixSwagger.Schema{ type: :object, properties: %{ name: %PhoenixSwagger.Schema{ type: :string, description: &quot;Full Name&quot;, }, dateOfBirth: %PhoenixSwagger.Schema{ type: :string, description: &quot;Date of birth&quot;, format: :datetime } }, required: [:name] }"},{"ref":"PhoenixSwagger.Schema.html#property/5","title":"PhoenixSwagger.Schema.property/5","type":"function","doc":"Sets a property of the Schema. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :object} ...&gt; |&gt; Schema.property(:name, :string, &quot;Full name&quot;, required: true, maxLength: 256) ...&gt; |&gt; Schema.property(:address, [:string, &quot;null&quot;], &quot;Street Address&quot;) ...&gt; |&gt; Schema.property(:friends, Schema.array(:User), &quot;Friends list&quot;, required: true) %PhoenixSwagger.Schema{ type: :object, properties: %{ friends: %PhoenixSwagger.Schema{ type: :array, description: &quot;Friends list&quot;, items: %PhoenixSwagger.Schema{&quot;$ref&quot;: &quot;#/definitions/User&quot;} }, address: %PhoenixSwagger.Schema{ type: [:string, &quot;null&quot;], description: &quot;Street Address&quot; }, name: %PhoenixSwagger.Schema{ type: :string, description: &quot;Full name&quot;, maxLength: 256 } }, required: [:friends, :name] }"},{"ref":"PhoenixSwagger.Schema.html#ref/1","title":"PhoenixSwagger.Schema.ref/1","type":"function","doc":"Construct a schema reference, using name of definition in this swagger document, or a complete path. Example iex&gt; PhoenixSwagger.Schema.ref(:User) %PhoenixSwagger.Schema{&quot;$ref&quot;: &quot;#/definitions/User&quot;} iex&gt; PhoenixSwagger.Schema.ref(&quot;../common/Error.json&quot;) %PhoenixSwagger.Schema{&quot;$ref&quot;: &quot;../common/Error.json&quot;}"},{"ref":"PhoenixSwagger.Schema.html#required/2","title":"PhoenixSwagger.Schema.required/2","type":"function","doc":"Makes one or more properties required in an object schema. ## Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :object, properties: %{phone_number: %Schema{type: :string}}} ...&gt; |&gt; Schema.required(:phone_number) %PhoenixSwagger.Schema{ type: :object, properties: %{ phone_number: %PhoenixSwagger.Schema{ type: :string } }, required: [:phone_number] } iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :object, properties: %{phone_number: %Schema{type: :string}, address: %Schema{type: :string}}} ...&gt; |&gt; Schema.required([:phone_number, :address]) %PhoenixSwagger.Schema{ type: :object, properties: %{ phone_number: %PhoenixSwagger.Schema{ type: :string }, address: %PhoenixSwagger.Schema{ type: :string } }, required: [:phone_number, :address] }"},{"ref":"PhoenixSwagger.Schema.html#title/2","title":"PhoenixSwagger.Schema.title/2","type":"function","doc":"Sets the title of the schema Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{} |&gt; Schema.title(&quot;User&quot;) %PhoenixSwagger.Schema{title: &quot;User&quot;}"},{"ref":"PhoenixSwagger.Schema.html#type/2","title":"PhoenixSwagger.Schema.type/2","type":"function","doc":"Sets the type of for the schema. Valid values are :string, :integer, :number, :object, :array, :boolean, :null, or a list of those basic types. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{} ...&gt; |&gt; Schema.type(:string) %PhoenixSwagger.Schema{type: :string} iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{} ...&gt; |&gt; Schema.type([:string, :integer]) %PhoenixSwagger.Schema{type: [:string, :integer]}"},{"ref":"PhoenixSwagger.Schema.html#unique_items/2","title":"PhoenixSwagger.Schema.unique_items/2","type":"function","doc":"Boolean that when true, requires each item of an array schema to be unique. Example iex&gt; alias PhoenixSwagger.Schema ...&gt; %Schema{type: :array} ...&gt; |&gt; Schema.unique_items(true) %PhoenixSwagger.Schema{type: :array, uniqueItems: true}"},{"ref":"PhoenixSwagger.SchemaTest.html","title":"PhoenixSwagger.SchemaTest","type":"module","doc":"Testing helper module that makes it convenient to assert that phoenix controller responses conform to a swagger spec. Example use YourApp.ConnCase use PhoenixSwagger.SchemaTest &quot;priv/static/swagger.json&quot; test &quot;Get a user by ID&quot;, %{conn: conn, swagger_schema: schema} do user = Repo.insert! struct(User, @valid_attrs) response = conn |&gt; get(user_path(conn, :show, user)) |&gt; validate_resp_schema(schema, &quot;UserResponse&quot;) |&gt; json_response(200) assert response[&quot;data&quot;][&quot;id&quot;] == user.id end Errors will be output with the json-path of the location in the response body for the error: Response JSON does not conform to swagger schema from #/definitions/UserResponse. At #/data/email: Expected &quot;foobaz&quot; to be an email address. { &quot;data&quot;: { &quot;name&quot;: &quot;Yu Ser&quot;, &quot;id&quot;: 141, &quot;email&quot;: &quot;foobaz&quot; } }"},{"ref":"PhoenixSwagger.SchemaTest.html#__using__/1","title":"PhoenixSwagger.SchemaTest.__using__/1","type":"macro","doc":"Given a swagger file path, defines an ExUnit setup_all block that will add the resolved swagger schema to the ExUnit context."},{"ref":"PhoenixSwagger.SchemaTest.html#validate_resp_schema/3","title":"PhoenixSwagger.SchemaTest.validate_resp_schema/3","type":"function","doc":"Validates a response body against a swagger schema. Example use MyApp.ConnCase use PhoenixSwagger.SchemaTest &quot;priv/static/swagger.json&quot; test &quot;get user by ID&quot;, %{conn: conn, swagger_schema: schema} do response = conn |&gt; get(user_path(conn, :show, 123)) |&gt; validate_resp_schema(schema, &quot;User&quot;) |&gt; json_response(200) assert response[&quot;data&quot;][&quot;id&quot;] == 123 end"},{"ref":"PhoenixSwagger.Validator.html","title":"PhoenixSwagger.Validator","type":"module","doc":"The PhoenixSwagger.Validator module provides converter of swagger schema to ex_json_schema structure for further validation. There are two main functions: parse_swagger_schema/1 validate/2 Before validate/2 will be called, a swagger schema should be parsed for futher validation with the parse_swagger_schema/1. This function takes path to a swagger schema and returns it in ex_json_schema format. During execution of the parse_swagger_schema/1 function, it creates the validator_table ets table and stores associative key/value there. Where key is an API path of a resource and value is input parameters of a resource. To validate of a parsed swagger schema, the validate/1 should be used. For more information, see more in ./phoenix_swagger/tests/ directory."},{"ref":"PhoenixSwagger.Validator.html#parse_swagger_schema/1","title":"PhoenixSwagger.Validator.parse_swagger_schema/1","type":"function","doc":"The parse_swagger_schema/1 takes path or list of paths to a swagger schema(s), parses it/them into ex_json_schema format and store to the validator_table ets table. Usage: iex(1)&gt; parse_swagger_schema(&quot;my_json_spec.json&quot;) [{&quot;/person&quot;, %{&#39;__struct__&#39; =&gt; &#39;Elixir.ExJsonSchema.Schema.Root&#39;, location =&gt; root, refs =&gt; %{}, schema =&gt; %{ &quot;properties&quot; =&gt; %{ &quot;name&quot; =&gt; %{&quot;type&quot; =&gt; &quot;string&quot;}, &quot;age&quot; =&gt; %{&quot;type&quot; =&gt; &quot;integer&quot;} } } } }]"},{"ref":"PhoenixSwagger.Validator.html#validate/2","title":"PhoenixSwagger.Validator.validate/2","type":"function","doc":"The validate/2 takes a resource path and input parameters of this resource. Returns :ok in a case when parameters are valid for the given resource or: {:error, :resource_not_exists} in a case when path is not exists in the validator table; {:error, error_message, path} in a case when at least one parameter is not valid for the given resource."},{"ref":"readme.html","title":"PhoenixSwagger","type":"extras","doc":"PhoenixSwagger PhoenixSwagger is the library that provides swagger integration to the phoenix web framework. Generate a swagger api specification from phoenix router and controllers Serve swagger-ui Validate requests against parameter schemas Validate responses against schemas in tests Installation Follow the getting started guide to install and configure PhoenixSwagger. Guides See the full documentation on hexdocs.pm or browse the docs directory. Contributing Issues and pull requests welcome. You&#39;ll also find help on the #phoenix_swagger channel on the elixir-lang slack. License Mozilla Public License 2.0"},{"ref":"getting-started.html","title":"Getting Started","type":"extras","doc":"Getting Started PhoenixSwagger provides a mix compiler and mix task phx.swagger.generate for the swagger-ui json file generation that contains swagger specification that describes API of the phoenix application. You just need to add the swagger DSL to your controllers and then run this one mix task to generate the json files."},{"ref":"getting-started.html#installation","title":"Getting Started - Installation","type":"extras","doc":"To use PhoenixSwagger with a phoenix application just add it to your list of dependencies in the mix.exs file: def deps do [ {:phoenix_swagger, &quot;~&gt; 0.8&quot;}, {:ex_json_schema, &quot;~&gt; 0.5&quot;} # optional ] end ex_json_schema is an optional dependency of phoenix_swagger required only for schema validation plug and test helper. Append :phoenix_swagger to the list of compilers to automatically update the swagger files each time the app is compiled: def project do [ ... compilers: [:phoenix, :gettext] ++ Mix.compilers ++ [:phoenix_swagger], ... end"},{"ref":"getting-started.html#configuration","title":"Getting Started - Configuration","type":"extras","doc":"Add a config entry to your phoenix application specifying the output filename, router and endpoint modules used to generate the swagger file: config :my_app, :phoenix_swagger, swagger_files: %{ &quot;priv/static/swagger.json&quot; =&gt; [ router: MyAppWeb.Router, # phoenix routes will be converted to swagger paths endpoint: MyAppWeb.Endpoint # (optional) endpoint config used to set host, port and https schemes. ] } If multiple swagger files need to be generated, add additional entries to the project config: config :my_app, :phoenix_swagger, swagger_files: %{ &quot;booking-api.json&quot; =&gt; [router: MyApp.BookingRouter], &quot;reports-api.json&quot; =&gt; [router: MyApp.ReportsRouter], &quot;admin-api.json&quot; =&gt; [router: MyApp.AdminRouter] } Also you can configure json library to use: config :phoenix_swagger, json_library: Jason"},{"ref":"getting-started.html#router","title":"Getting Started - Router","type":"extras","doc":"The outline of the swagger document should be returned from a swagger_info/0 function defined in your phoenix Router.ex module. defmodule MyApp.Router do use MyApp.Web, :router pipeline :api do plug :accepts, [&quot;json&quot;] end scope &quot;/api&quot;, MyApp do pipe_through :api resources &quot;/users&quot;, UserController end def swagger_info do %{ info: %{ version: &quot;1.0&quot;, title: &quot;My App&quot; } } end end The version and title are mandatory fields. By default the version will be 0.0.1 and the title will be &lt;enter your title&gt; if you do not provide swagger_info/0 function. See the Swagger Object specification for details of other information that can be included. basePath is optional but may need to be specified if your API routes do not reside at the root location /. You can also set the description of tags here, for example: %{ basePath: &quot;/api&quot;, info: %{..}, tags: [%{name: &quot;Users&quot;, description: &quot;Operations about Users&quot;}] }"},{"ref":"getting-started.html#endpoint","title":"Getting Started - Endpoint","type":"extras","doc":"The swagger host value is built from your phoenix Endpoint url config. # config.exs config :my_app, MyApp.Web.Endpoint, url: [host: &quot;localhost&quot;], # &quot;host&quot;: &quot;localhost:4000&quot; in generated swagger If the host is configured to be set dynamically (either by {:systems, &quot;VAR&quot;} tuples or the :load_from_system_env flag), the swagger host will be omitted. SwaggerUI will default to sending requests to the same host that is serving the swagger file. # prod.exs config :my_app, MyApp.Web.Endpoint, load_from_system_env: true, # Expects url host and port to be configured in Endpoint.init callback url: [host: &quot;example.com&quot;, port: 80],"},{"ref":"getting-started.html#generate-swagger-file","title":"Getting Started - Generate Swagger File","type":"extras","doc":"Once you have a minimal configuration and swagger_info function in the router, run the phx.swagger.generate mix task for the swagger json file generation into directory with phoenix application: mix phx.swagger.generate"},{"ref":"schemas.html","title":"Schemas","type":"extras","doc":"Schemas Schema definitions are placed in a swagger_definitions/0 function within each controller module. This function should return a map in the format of a swagger definitionsObject. The swagger_schema/2 macro can be used to build a schema definition using the functions provided by the PhoenixSwagger.Schema module. Example: def swagger_definitions do %{ User: swagger_schema do title &quot;User&quot; description &quot;A user of the application&quot; properties do name :string, &quot;Users name&quot;, required: true id :string, &quot;Unique identifier&quot;, required: true address :string, &quot;Home address&quot; preferences (Schema.new do properties do subscribe_to_mailing_list :boolean, &quot;mailing list subscription&quot;, default: true send_special_offers :boolean, &quot;special offers list subscription&quot;, default: true end end) end example %{ name: &quot;Joe&quot;, id: &quot;123&quot;, address: &quot;742 Evergreen Terrace&quot; } end, Users: swagger_schema do title &quot;Users&quot; description &quot;A collection of Users&quot; type :array items Schema.ref(:User) end } end"},{"ref":"operations.html","title":"Operations","type":"extras","doc":"Operations PhoenixSwagger provides swagger_path/2 macro that generates swagger specification for the certain phoenix controller action. Example: use PhoenixSwagger swagger_path :index do get &quot;/posts&quot; description &quot;List blog posts&quot; response 200, &quot;Success&quot; end def index(conn, _params) do posts = Repo.all(Post) render(conn, &quot;index.json&quot;, posts: posts) end The swagger_path macro takes two parameters: Name of controller action; do block that contains the swagger specification for the controller action. Within the do-end block, the DSL provided by the PhoenixSwagger.Path module can be used. Example: swagger_path :index do get &quot;/api/v1/{org_id}/users&quot; summary &quot;Query for users&quot; description &quot;Query for users. This operation supports with paging and filtering&quot; produces &quot;application/json&quot; tag &quot;Users&quot; operation_id &quot;list_users&quot; paging parameters do org_id :path, :string, &quot;Organization ID&quot;, required: true zipcode :query, :string, &quot;Address Zip Code&quot;, required: true, example: &quot;90210&quot; include :query, :array, &quot;Related resources to include in response&quot;, items: [type: :string, enum: [:organisation, :favourites, :purchases]], collectionFormat: :csv end response 200, &quot;OK&quot;, Schema.ref(:Users) response 400, &quot;Client Error&quot; end The swagger_path macro layer is just some syntactic sugar over regular elixir functions. Therefore it can easily be extended, for instance, if we want to reuse some common parameters. For more details on this take a look at Reusing Swagger Parameters. Note the imported PhoenixSwagger.Path.delete/2 function may clash with your own delete/2 function in the controller. Often you can just remove this function call, since the route will be inferred automatically. If you need to customize the route for swagger, then use a qualified function call to disambiguate: swagger_path :delete do PhoenixSwagger.Path.delete &quot;/api/users/{id}&quot; summary &quot;Delete User&quot; description &quot;Delete a user by ID&quot; parameter :id, :path, :integer, &quot;User ID&quot;, required: true, example: 3 response 203, &quot;No Content - Deleted Successfully&quot; end"},{"ref":"reusing-swagger-parameters.html","title":"Reusing swagger parameters","type":"extras","doc":"Reusing swagger parameters When building an API it can be common to have headers or parameters that are common to multiple actions."},{"ref":"reusing-swagger-parameters.html#scenario","title":"Reusing swagger parameters - Scenario","type":"extras","doc":"For example, let&#39;s say we&#39;ve got two endpoints: GET /projects GET /books Both of these endpoints can be sorted using by sort_by and sort_direction parameters and both require an Authorization header. Here&#39;s what the swagger spec in our ProjectsController would look like: defmodule ProjectsController do use PhoenixSwagger swagger_path :index do get &quot;/projects&quot; produces &quot;application/json&quot; parameter(&quot;Authorization&quot;, :header, :string, &quot;OAuth2 access token&quot;, required: true) parameters do sort_by :query, :string, &quot;The property to sort by&quot; sort_direction :query, :string, &quot;The sort direction&quot;, enum: [:asc, :desc], default: :asc company_id :string, :query, &quot;The company id&quot; end end end Our BooksController swagger would look very similar, also defining the Authorization header and the sort_by and sort_direction headers."},{"ref":"reusing-swagger-parameters.html#extracting-parameters-into-a-module-for-reuse","title":"Reusing swagger parameters - Extracting parameters into a module for reuse","type":"extras","doc":"The swagger_path macro layer is actually just some syntactic sugar over regular elixir functions, intended to be easily extended. Any function that accepts a %PhoenixSwagger.Path.PathObject{} as its first argument and returns an updated %PathObject{} can be used in the swagger_path macro. Knowing this, we can easily extract some of the common logic into a module and reuse it in our controllers. defmodule CommonParameters do @moduledoc &quot;Common parameter declarations for phoenix swagger&quot; alias PhoenixSwagger.Path.PathObject import PhoenixSwagger.Path def authorization(path = %PathObject{}) do path |&gt; parameter(&quot;Authorization&quot;, :header, :string, &quot;OAuth2 access token&quot;, required: true) end def sorting(path = %PathObject{}) do path |&gt; parameter(:sort_by, :query, :string, &quot;The property to sort by&quot;) |&gt; parameter(:sort_direction, :query, :string, &quot;The sort direction&quot;, enum: [:asc, :desc], default: :asc) end end This can also be done using the parameters macro: def sorting(path = %PathObject{}) do parameters path do sort_by :query, :string, &quot;The property to sort by&quot; sort_direction :query, :string, &quot;The sort direction&quot;, enum: [:asc, :desc], default: :asc end end"},{"ref":"reusing-swagger-parameters.html#reusing-the-common-parameters","title":"Reusing swagger parameters - Reusing the common parameters","type":"extras","doc":"Now, instead of defining these parameters in every controller, we can just reference the CommonParameters module: defmodule ProjectsController do use PhoenixSwagger swagger_path :index do get &quot;/users&quot; produces &quot;application/json&quot; CommonParameters.authorization CommonParameters.sorting parameters do company_id :string, :query, &quot;The company id&quot; end end end"},{"ref":"swagger-ui.html","title":"Swagger UI","type":"extras","doc":"Swagger UI PhoenixSwagger includes a plug with all static assets required to host swagger-ui from your Phoenix application. Usage: Generate a swagger file in your applications priv/static dir: config :my_app, :phoenix_swagger, swagger_files: %{ &quot;priv/static/swagger.json&quot; =&gt; [router: MyAppWeb.Router] } mix phx.swagger.generate Add a swagger scope to your router, and forward all requests to SwaggerUI scope &quot;/api/swagger&quot; do forward &quot;/&quot;, PhoenixSwagger.Plug.SwaggerUI, otp_app: :myapp, swagger_file: &quot;swagger.json&quot; end Run the server with mix phx.server and browse to localhost:4000/api/swagger, Swagger-ui should be shown with your swagger spec loaded. See the examples/simple project for a runnable example with swagger-ui."},{"ref":"schema-validation.html","title":"Schema Validation","type":"extras","doc":"Schema Validation Besides generator of swagger schemas, the phoenix_swagger provides validator of input parameters of resources. Suppose you have following resource in your schema: ... ... &quot;/history&quot;: { &quot;get&quot;: { &quot;parameters&quot;: [ { &quot;name&quot;: &quot;offset&quot;, &quot;in&quot;: &quot;query&quot;, &quot;type&quot;: &quot;integer&quot;, &quot;format&quot;: &quot;int32&quot;, &quot;description&quot;: &quot;Offset the list of returned results by this amount. Default is zero.&quot; }, { &quot;name&quot;: &quot;limit&quot;, &quot;in&quot;: &quot;query&quot;, &quot;type&quot;: &quot;integer&quot;, &quot;format&quot;: &quot;int32&quot;, &quot;description&quot;: &quot;Integer of items to retrieve. Default is 5, maximum is 100.&quot; }] } } ... ... The phoenix_swagger provides PhoenixSwagger.Validator.parse_swagger_schema/1 API to load a swagger schema by the given path or list of paths. This API should be called during application startup to parse/load a swagger schema. After this, use one of the following to validate resources: the function PhoenixSwagger.Validator.validate/2 using request path and parameters the default Plug PhoenixSwagger.Plug.Validate the function PhoenixSwagger.ConnValidate.validate/1 using conn Validator.validate/2 For example: iex(1)&gt; Validator.validate(&quot;/history&quot;, %{&quot;limit&quot; =&gt; &quot;10&quot;}) {:error,&quot;Type mismatch. Expected Integer but got String.&quot;, &quot;#/limit&quot;} iex(2)&gt; Validator.validate(&quot;/history&quot;, %{&quot;limit&quot; =&gt; 10, &quot;offset&quot; =&gt; 100}) :ok Default Plug To validate input parameters of your controllers with the default Plug, just add PhoenixSwagger.Plug.Validate to your router: pipeline :api do plug :accepts, [&quot;json&quot;] plug PhoenixSwagger.Plug.Validate end scope &quot;/api&quot;, MyApp do pipe_through :api post &quot;/users&quot;, UsersController, :send end On validation errors, the default Plug returns 400 with the following body: { &quot;error&quot;: { &quot;path&quot;: &quot;#/path/to/schema&quot;, &quot;message&quot;: &quot;Expected integer, got null&quot; } } The return code for validation errors is configurable via :validation_failed_status parameter. If conn.private[:phoenix_swagger][:valid] is set to true, the Plug will skip validation. ConnValidator.validate/1 Use ConnValidator.validate/1 to build your own Plugs. It accepts a conn and returns :ok on validation success. Refer to source for error cases."},{"ref":"test-helpers.html","title":"Test Helpers","type":"extras","doc":"Test Helpers PhoenixSwagger also includes a testing helper module PhoenixSwagger.SchemaTest to conveniently assert that responses from Phoenix controller actions conform to your swagger schema. In your controller test files add the PhoenixSwagger.SchemaTest mixin with the path to your swagger spec: defmodule YourApp.UserControllerTest do use YourApp.ConnCase, async: true use PhoenixSwagger.SchemaTest, &quot;priv/static/swagger.json&quot; Then in each test, the context will contain the swagger_schema, which can be used with the validate_resp_schema function: test &quot;shows chosen resource&quot;, %{conn: conn, swagger_schema: schema} do user = Repo.insert! struct(User, @valid_attrs) response = conn |&gt; get(user_path(conn, :show, user)) |&gt; validate_resp_schema(schema, &quot;UserResponse&quot;) |&gt; json_response(200) end"},{"ref":"live-reloading.html","title":"Live Reloading","type":"extras","doc":"Live Reloading Live reloading can be use to automatically regenerate the swagger files and reload the swagger-ui when controller files change. To enable live reloading: Ensure phoenix_swagger is added as a compiler in your mix.exs file Add the path to the swagger json files and controllers to the endpoint live_reload config Add the reloadable_compilers configuration to the endpoint config, including the :phoenix_swagger compiler config :your_app, YourApp.Endpoint, live_reload: [ patterns: [ ~r{priv/static/.*(js|css|png|jpeg|jpg|gif|svg|json)$}, ~r{priv/gettext/.*(po)$}, ~r{lib/your_app_web/views/.*(ex)$}, ~r{lib/your_app_web/controllers/.*(ex)$}, ~r{lib/your_app_web/templates/.*(eex)$} ] ], reloadable_compilers: [:gettext, :phoenix, :elixir, :phoenix_swagger]"},{"ref":"json-api-helpers.html","title":"JSON:API Helpers","type":"extras","doc":"JSON:API Helpers The PhoenixSwagger.JsonApi module provides helpers for constructing JSON:API schemas easily. PhoenixSwagger.JsonApi.resource/1 describes a JSON:API resource object. PhoenixSwagger.JsonApi.page/1 and PhoenixSwagger.JsonApi.single/1 can then be used to wrap a resource in a JSON:API top level object Example: use PhoenixSwagger def swagger_definitions do %{ UserResource: JsonApi.resource do description &quot;A user that may have one or more supporter pages.&quot; attributes do phone :string, &quot;Users phone number&quot; full_name :string, &quot;Full name&quot; user_updated_at :string, &quot;Last update timestamp UTC&quot;, format: &quot;ISO-8601&quot; user_created_at :string, &quot;First created timestamp UTC&quot; email :string, &quot;Email&quot;, required: true birthday :string, &quot;Birthday in YYYY-MM-DD format&quot; address Schema.ref(:Address), &quot;Users address&quot; end link :self, &quot;The link to this user resource&quot; relationship :preferences relationship :posts, type: :has_many end, Users: JsonApi.page(:UserResource), User: JsonApi.single(:UserResource) } end swagger_path :index do get &quot;/api/v1/users&quot; paging size: &quot;page[size]&quot;, number: &quot;page[number]&quot; response 200, &quot;OK&quot;, Schema.ref(:Users) end"}]